 require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/generics', type: :request do
  let(:valid_attributes) { {rca_id: rca.id, tool_reference: 1, tool_num: 1, doc: doc_ok} }
  let(:invalid_attributes) { {rca_id: nil, tool_reference: 1, doc: doc_ok} }

  let(:doc_ok) do
    ActiveStorage::Blob.create_and_upload!(
      io: File.open(file_ok, 'rb'),
      filename: 'not_image.pdf',
      content_type: 'file/pdf'
    ).signed_id
  end
  let(:doc_ok2) do
    ActiveStorage::Blob.create_and_upload!(
      io: File.open(file_ok, 'rb'),
      filename: 'not_image_v2.pdf',
      content_type: 'file/pdf'
    ).signed_id
  end
  let(:image_ok) do
    ActiveStorage::Blob.create_and_upload!(
      io: File.open(file_ok, 'rb'),
      filename: 'image_ok.png',
      content_type: 'image/png'
    ).signed_id
  end

  let(:file_ok) { Rails.root.join('spec', 'support', 'assets', 'images', 'not_image.pdf') }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_generic = Tools::Generic.create! valid_attributes
        get edit_tools_generic_url(tools_generic)
        expect(response).to be_successful
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {synthesis: 'Blablablablabla'} }

        it 'updates the requested tools_generic' do
          tools_generic = Tools::Generic.create! valid_attributes
          patch tools_generic_url(tools_generic), params: { tools_generic: new_attributes }
          tools_generic.reload
          expect(tools_generic.synthesis).to eq 'Blablablablabla'
        end

        it 'redirects to the tools_generic edition view' do
          tools_generic = Tools::Generic.create! valid_attributes
          patch tools_generic_url(tools_generic), params: { tools_generic: new_attributes }
          tools_generic.reload
          expect(response).to redirect_to(edit_tools_generic_url(tools_generic))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_generic = Tools::Generic.create! valid_attributes
          patch tools_generic_url(tools_generic), params: { tools_generic: invalid_attributes }
          expect(response).to be_successful
        end
      end

      context 'with image' do
        let(:img_attributes) { {images: [image_ok]} }
        it 'adds a new image to images' do
          tools_generic = Tools::Generic.create! valid_attributes
          # patch tools_generic_url(tools_generic), params: { tools_generic: img_attributes }
          # tools_generic.reload

          # second image
          expect {
            patch tools_generic_url(tools_generic), params: { tools_generic: img_attributes }
          }.to change(tools_generic.images, :count).by(1)

          tools_generic.reload
          expect(tools_generic.images.attached?).to eq true
          expect(tools_generic.images.first.filename).to eq 'image_ok.png'
        end
      end

      context 'with doc' do
        let(:doc_attributes) { {doc: doc_ok2} }
        it 'adds a doc and copy old doc in file_versions' do
          tools_generic = Tools::Generic.create! valid_attributes
          patch tools_generic_url(tools_generic), params: { tools_generic: doc_attributes }
          tools_generic.reload
          expect(tools_generic.file_versions.size).to eq 1
          expect(tools_generic.doc.filename).to eq 'not_image.pdf'
          expect(tools_generic.file_versions.first.file.filename).to eq 'not_image_v2.pdf'
        end

        it 'adds a doc and copy old doc in file_versions and delete if > 2 versions' do
          config = Admin::AdminConfig.create!
          config.options['file_versions_nb_max'] = 2
          config.save!

          tools_generic = Tools::Generic.create! valid_attributes
          patch tools_generic_url(tools_generic), params: { tools_generic: doc_attributes }
          tools_generic.reload
          expect(tools_generic.file_versions.size).to eq 1

          patch tools_generic_url(tools_generic), params: { tools_generic: doc_attributes }
          tools_generic.reload
          expect(tools_generic.file_versions.size).to eq 2

          patch tools_generic_url(tools_generic), params: { tools_generic: doc_attributes }
          tools_generic.reload
          expect(tools_generic.file_versions.size).to eq 2
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'do not destroy the tool tools_generic' do
        tools_generic = Tools::Generic.create! valid_attributes.merge(images: [image_ok])
        expect {
          delete tools_generic_url(tools_generic)
        }.to change(Tools::Generic, :count).by(0)
      end

      it 'destroys the requested IMAGE attached to tools_generic' do
        tools_generic = Tools::Generic.create! valid_attributes.merge(images: [image_ok])
        expect {
          delete tools_generic_url(tools_generic, image_attachment_id: tools_generic.images.first.id)
        }.to change(tools_generic.images, :count).by(-1)
      end

      it 'redirects to the tools_generics list' do
        tools_generic = Tools::Generic.create! valid_attributes
        delete tools_generic_url(tools_generic)
        expect(response).to redirect_to(edit_tools_generic_url(tools_generic))
      end
    end

    describe 'GET /download_last_doc' do
      it 'download last doc version' do
        tools_generic = Tools::Generic.create! valid_attributes.merge(doc: doc_ok)

        get tools_generics_download_last_doc_url(id: tools_generic.id)
        # expect download = tools_generic.doc
        expect(response).to be_successful

        patch tools_generic_url(tools_generic), params: { tools_generic: {doc: doc_ok2} }
        tools_generic.reload
        get tools_generics_download_last_doc_url(id: tools_generic.id)
        # expect download = tools_generic.file_versions.first.file
        expect(response).to be_successful
      end
    end
  end
end
